/******************************************************************************
df, (c) Uri Fridman - uri@ufridman.org
This code is released under the GPL, free. there are no warranties, see
the file COPYING.txt for more information.
*******************************************************************************/
#include <windows.h>
#include <stdio.h>


void PrintInfo()
{
	printf("df - print information about disk free and total space\n");
	printf("version 1.0 by Uri, ufridman.org\n");
	printf("Use at your own risk, there are no warranties\n\n");
	printf("Usage:\n");
	printf("    df [NO ARGUMENTS]\n");
	return;
}


int main (int argc, char **argv)
{
	DWORD d = GetLogicalDrives();
	int i;
	unsigned __int64 freeSpace = 0;
	unsigned __int64 totalSpace = 0;
	unsigned __int64 totalFreeSpace = 0;
	WCHAR Drive[] = L"A:\\";
	WCHAR lpVolumeNameBuffer[MAX_PATH] = {'\0'};
	WCHAR lpFileSystemNameBuffer[MAX_PATH] = {'\0'};
	BOOL res;

	if(argc > 1)
	{
		PrintInfo();
		return 1;
	}


	printf("Drive\t Total(GB)\t Free(GB)\t Filesystem\n");
	for(i=0; i<32; i++)
	{
		if(d & (1<<i))
		{	
			memset(lpVolumeNameBuffer, '\0', MAX_PATH);
			memset(lpFileSystemNameBuffer, '\0', MAX_PATH);
			freeSpace = 0;
			totalSpace = 0;
			totalFreeSpace = 0;

			Drive[0] = 'A' + i;
			GetDiskFreeSpaceEx(Drive, 
				(PULARGE_INTEGER)&freeSpace, 
				(PULARGE_INTEGER)&totalSpace, 
				(PULARGE_INTEGER)&totalFreeSpace);
			
			res = GetVolumeInformation(Drive, lpVolumeNameBuffer,
				MAX_PATH, NULL, NULL, NULL, lpFileSystemNameBuffer, MAX_PATH); 
			
			if(res)
			{
				printf("%ls\t %I64u\t\t %I64u\t\t %ls\n", 
					Drive, totalSpace / (1024*1024*1024), 
					totalFreeSpace / (1024*1024*1024), lpFileSystemNameBuffer);
			}
			else
			{
				printf("%ls\t %I64u\t\t %I64u\t\t Unknown\n", 
					Drive, totalSpace / (1024*1024*1024), 
					totalFreeSpace / (1024*1024*1024));
			}
		}
	}

	return 0;
}
